<template>
  <v-chip-group
    v-model="model"
    multiple
    :selected-class="variant !== 'assist' ? 'bg-primary text-surface' : undefined"
    :disabled="disabled"
    @update:model-value="update"
  >
    <svn-pro-chip
      v-for="(chip, index) in chips"
      :key="index"
      draggable
      :filter="variant !== 'assist'"
      variant="outlined"
      :text="chip"
      :value="chip"
      :pill="avatar"
      :elevation="elevation"
      :rounded="variant === 'input' ? avatar ? 'pill' : 'lg' : 'lg'"
      :filter-icon="filterIcon"
      :disabled="disabled"
      :prepend-icon="model?.includes(chip) ? undefined : prependIcon"
      :append-icon="appendIcon"
      :closable="closable"
      close-icon="mdi-close"
    >
      <template v-if="avatar" #prepend>
        <div class="ml-1.5">
          <svn-pro-avatar
            v-if="!model?.includes(chip)"
            :type="avatarType"
            :image="avatarImage"
            :firstname="chip"
            :size="24"
            start
          />
        </div>
      </template>
    </svn-pro-chip>
  </v-chip-group>
</template>

<script setup>
import { ref, watch, onMounted } from 'vue';
import SvnProAvatar from '../../components/avatar/SvnProAvatar.vue';
import SvnProChip from '../../components/chip/SvnProChip.vue';

onMounted(() => {
  model.value = props?.modelValue
});

const emit = defineEmits(['update:modelValue']);

const model = ref(null);

const props = defineProps({
  variant: {
    type: String,
    default: 'input',
  },
  text: {
    type: String,
    default: 'Label',
  },
  prependIcon: {
    type: String,
    default: undefined,
  },
  appendIcon: {
    type: String,
    default: undefined,
  },
  closable: {
    type: Boolean,
    default: false,
  },
  avatar: {
    type: Boolean,
    default: false,
  },
  filterIcon: {
    type: String,
    default: undefined,
  },
  avatarType: {
    type: String,
    default: 'monogram',
  },
  avatarImage: {
    type: String,
    default: undefined,
  },
  disabled: {
    type: Boolean,
    default: false,
  },
  elevation: {
    type: Number,
    default: undefined,
  },
  chips: {
    type: Array,
    default: () => [],
  },
});

const update = () => {
  emit('update:modelValue', model?.value)
}

watch(props, (newValue, oldValue) => {
  if (newValue?.modelValue) {
    model.value = newValue?.modelValue;
  }
})
</script>